

  _clkmode = xtal1 + pll16x                             ' use crystal x 16
  _xinfreq = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)
  cr  = 13
OBJ
tv : "TV_Text"

var
long prime,targetnum,done
long stack1[3000],stack2[3000]
long temp,i,ii,iii,cog,okay 



PUB start | time1,time  
tv.start(12)
waitcnt(cnt + clkfreq)
stop
stack1[0]:=1
stack1[1]:=0
stack2[1]:=2
targetnum:=2
prime:=1

done:=0
time1:=cnt
cog := cognew(@init_asm,@stack1)
'waitcnt(cnt + clkfreq*2)
tv.out(13)
ii:=0
repeat until  done==1
time:=cnt   - time1
repeat 750
  temp:=stack1[ii]

  tv.dec(temp)
  tv.str(string("     "))
  tv.dec(stack2[ii])
  tv.out(13)
  ii++

tv.dec(targetnum)
tv.out(13)
tv.str(string("t1: "))
tv.dec(stack1[2999])
tv.str(string("     t2:="))
temp:=stack1[2998]
tv.dec(temp)

temp:=(80_000_000)/(stack1[2999]-stack1[2998])
tv.out(13)
tv.dec(temp)
tv.str(string("  parts of a second"))
tv.out(13)
tv.str(string("total time=time/80_000_000    "))
time:=time/80_000_000
tv.dec(time)

repeat

PUB stop

'' Stop TV driver - frees a cog

  if cog
    cogstop(cog~ - 1)
DAT

              org 0
init_asm
              mov s1, par                    'get address of stack1 into s1
             ' rdlong  primes,s1              'read number of primes (stack1[0]) into primes
              sub s1,#4
              mov done_,s1
              sub s1,#4
              mov targetnum_,s1                'address of targetnum
              sub s1,#4
              mov isprime,s1
              add s1,#16                       's1 now points to stack1[1]
              wrlong zero,s1                  'put zero into stack1[1]
              mov s2, par
              add s2,stackbytes                  'get address of stack2 into s2
              sub s2,#4
              mov t2,s2                        'get address of time2... t2
              sub s2,#4
              mov t1,s2                         'get address of time1... t1
              add s2,#12                        'get address of stack2[1] into s2
              wrlong two,s2
              rdlong count,reps'stacksize
                             'stacksize will get one prime for every loc in stack
              mov counter,cnt
              wrlong counter,t1
do_loop
         
              rdlong temp_, targetnum_
              add    temp_, #1
              wrlong temp_, targetnum_
              rdlong primes,par
              mov s1,par
              add s1,#4                          's1 points at stack1[1]
              mov s2, par
              add s2,stackbytes                  'get address of stack2 into s2
              add s2,#4                          's2 points at stack2[1]
              wrlong one, isprime
              call #inloop
              rdlong temp3_,isprime
              cmp temp3_,one wz
      if_nz   djnz count, #do_loop
              rdlong primes,par
              add  primes,#1
              wrlong primes,par
      
              wrlong temp_,s2
              rdlong  temp_,par
              cmp temp_,reps  wz               'number of primes to find
              if_z wrlong one,done_
              mov counter,cnt
              wrlong counter,t2
              if_z    cogid c  
              if_z    cogstop c
              djnz count, #do_loop
             
              
inloop    
              rdlong modval_,s1
              add modval_,one
              wrlong modval_,s1
        
              rdlong primeval_,s2
              cmp modval_,primeval_  wz
          if_z wrlong zero,isprime
          if_z wrlong zero,s1
              add s1,#4
              add s2,#4
              rdlong temp2_,s2
              tjnz temp2_,#inloop
              
inloop_ret    ret              
              


stacksize   long 3000
stackbytes  long 12000
one         long 1
two         long 2
zero        long 0
reps        long 100
primes      long 1
s1          res 1                       'for stack1    address
s2          res 1                       'for stack2    address
count       res 1
c           res 1
done_       res 1
targetnum_  res 1
modval_     res 1
primeval_   res 1
temp_       res 1
temp2_      res 1
temp3_      res 1
isprime     res 1
t1          res 1
t2          res 1
counter     res 1